/* *****************************************************************************
 * 
 * Description: Write a static function that takes an int array a[] and an integer 
 *              m as arguments and returns an array of length m whose ith 
 *              element is the number of times the integer i appeared in a[]. 
 *              Assume that the values in a[] are all between 0 and m-1; thus, 
 *              the sum of the values in the returned array must equal 
 *              a.length.  Note: this function must not modify a[].
 *          
 *              The program reads a sequence of integers from standard input 
 *              assume at least one) and prints the histogram.
 *
 **************************************************************************** */
public class Histogram {   
    // Create new hist array of length m.
    public static _____ histogram(_____, _____) {
        // Create new hist array of length m.
        _____

            // Loop through a, and populate the hist array.
            for (_____; _____; _____) {
                int element = _____;
                hist[_____]++;
            }

        return hist;
    }

    // Given an int[] hist array that represents a histogram for values
    // 0 to hist.length - 1, print a visualization of the histogram.
    public static void printHistogram(int[] hist) {
        // Find largest count in histogram.
        int max = 0;
        for (int i = 0; i < hist.length; i++) {
            if (hist[i] > max)
                max = hist[i];
        }

        // Print histogram values.
        for (int n = 0; n < max; n++) {
            for (int i = 0; i < hist.length; i++) {
                if (hist[i] >= max - n)
                    StdOut.print("x\t");
                else
                    StdOut.print(" \t");
            }
            StdOut.println();
        }

        // Print histogram bin labels.
        for (int i = 0; i < hist.length; i++) {
            StdOut.print(i + "\t");
        }
        StdOut.println();
    }

    // test client
    public static void main(String[] args) {
        // Read input.
        int[] values = StdIn.readAllInts();

        // Find maximum in values.
        int max = values[0];
        for (int i = 0; i < values.length; i++) {
            if (values[i] > max)
                max = values[i];
        }

        int[] hist = histogram(values, max + 1);
        printHistogram(hist);
    }
}
