/******************************************************************************
 *  Description: MaxVal finds the index of the element that contains the 
 *               maximum element in an array. 
 *
 *  Remarks:  Notice that both functions have the same name.
 *            How does Java know which max() will be called?
 *
 *  Java Visualizer:
 *   https://cscircles.cemc.uwaterloo.ca/java_visualize/
 * 
 *****************************************************************************/

public class MaxVal {
    // return the index of the maximum of a double array
    // assume array has *at least one value*
    public static ___ max(_____ a) {
        StdOut.println("debugging: running the first method");
        int n = a.length;
        int index = -1;  

        // initialize value so that a[0]
        // must be greater than this value!
        double value = Double.NEGATIVE_INFINITY;
        
        // find index of max value in array
        for (int i = 0; i < n; i++) { // loop over all values
            if (a[i] > _ value) {     // if a[i] > current max
                index = ____;         // save index of current max
                value = ____;         // save value of current max
            }
        }

        // return index
        return ____;

    }


    // return the index of the maximum of an int array
    // assume array has *at least one value*
    public static ___ max(____ a) {
        StdOut.println("debugging: running the second method");
        
        int n = a.length;
        int index = -1;

        // initialize value so that a[0]
        // must be greater than this value!
        int value = Integer.MIN_VALUE;

        // find index of max value in array
        for ___

        // return index
        ______
        
    }

    // demonstrates overloaded functions
    public static void main(String[] args) {

        // create two arrays
        double[] arr1 = {1.0, -3.0, 5, 6.6, 2, 3.14};
        int[] arr2 = {14, -1, 12, 1, 1};

        // print the element with the largest value arr1
        int i = max(arr1);
        StdOut.printf("Element %d has the maximum value %.6f\n", i, arr1[i]);
        // print the element with the largest value arr2
        i = max(arr2);
        StdOut.printf("Element %d has the maximum value %d\n", i, arr2[i]);
    }     
}
